
The GAP 4 Package **CTBlocks**
==============================

What is it?
-----------

It is an add-on package
for the computer algebra system
[**GAP 4**](https://www.gap-system.org/).

Currently it consists of

* Character theoretic GAP functions for questions about p-blocks and

* some examples where these functions can be used.


Download and Installation
-------------------------

To get the newest released version,

* download the archive file
  (where `x.y` stands for the highest available version number)

  `ctblocks-x.y.tar.gz`

  from [the homepage of the package](http://www.math.rwth-aachen.de/~Thomas.Breuer/ctblocks),

* move it to the appropriate directory, preferably
  (but not necessarily) into the `pkg` subdirectory of your GAP 4 installation,
  see the sections
  ["Installing a GAP Package"](https://www.gap-system.org/Manuals/doc/ref/chap76.html) and
  ["GAP Root Directories"](https://www.gap-system.org/Manuals/doc/ref/chap9.html) in
  [the GAP 4 Reference Manual](https://www.gap-system.org/Manuals/doc/ref/chap0.html),

* and unpack it using

```
gunzip ctblocks-x.y.tar.gz; tar xvf ctblocks-x.y.tar
```

Note that if you use a web browser for downloading the archive file
the `gunzip` step above may already be done by the browser,
although the name of your file may still have the misleading `.gz` extension.

Unpacking the archive creates a subdirectory called `ctblocks-x.y`.


Loading the library into the GAP session
----------------------------------------

After its installation (see above),
the package can be loaded by typing

```
gap> LoadPackage( "ctblocks" );`
```

at the GAP prompt.
Then the functions and data of the package are available
in the current GAP session.


Documentation
-------------

The **package manual** is available
[in HTML format](http://www.math.rwth-aachen.de/~Thomas.Breuer/ctblocks/doc/chap0.html)
or [as a PDF file](http://www.math.rwth-aachen.de/~Thomas.Breuer/ctblocks/doc/manual.pdf).

A few **introductory examples** can be found in the
["Tutorial" chapter of the package manual](http://www.math.rwth-aachen.de/~Thomas.Breuer/ctblocks/doc/chap2.html).

You can read the tutorial inside the GAP session
via GAP's interactive help system by entering

```
gap> ?CTBlocks`
gap> ?Tutorial for the CTBlocks Package`
```

at the GAP prompt.


Feedback
--------

If you have found important features missing or if there is a bug,
let us know and we will try to address it in the next version of the
package.
Please send a short email to

  Thomas Breuer (<sam@math.rwth-aachen.de>)

This holds also if you have used the package
to solve a problem.


License
-------

This package may be distributed under the terms and conditions of the
[**GNU Public License**](http://www.gnu.org/licenses) Version 3 or later.


Acknowledgement
---------------

Thomas Breuer gratefully acknowledges support by
the German Research Foundation (DFG) within the
[SFB-TRR 195 *Symbolic Tools in Mathematics and their Applications*](https://www.computeralgebra.de/sfb/).

                            Thomas Breuer (Thomas.Breuer@Math.RWTH-Aachen.De)
