# This file was created automatically, do not edit!
#############################################################################
##
#W  docxpl.tst             GAP 4 package CTBlocks               Thomas Breuer
##
#Y  Copyright (C)  2022,   Lehrstuhl D für Mathematik,  RWTH Aachen,  Germany
##
##  This file contains the GAP code of examples in the package
##  documentation files.
##  
##  In order to run the tests, one starts GAP from the 'tst' subdirectory
##  of the 'pkg/ctblocks' directory, and calls 'Test( "docxpl.tst" );'.
##  

gap> LoadPackage( "CTBlocks", false );
true
gap> save:= SizeScreen();;
gap> SizeScreen( [ 72 ] );;
gap> START_TEST( "docxpl.tst" );

##
gap> if IsBound( BrowseData ) then
>      data:= BrowseData.defaults.dynamic.replayDefaults;
>      oldinterval:= data.replayInterval;
>      data.replayInterval:= 1;
>    fi;

##  doc/tutorial.xml (45-48)
gap> origpref:= UserPreference( "AtlasRep", "DisplayFunction" );;
gap> SetUserPreference( "AtlasRep", "DisplayFunction", "Print" );

##  doc/tutorial.xml (60-81)
gap> DisplayBlockInvariants( "2.A6" );
Block invariants for 2.A6

----------------------------------------------
| p | b | d | k | l | c | a | n | f | r | sr |
----------------------------------------------
| 2 | 1 | 4 | 9 | 3 | - | - | - | + | + |  + |
|   | 2 | 1 | 2 | 1 | + | + | + | + | + |  - |
|   | 3 | 1 | 2 | 1 | + | + | + | + | + |  - |
| 3 | 1 | 2 | 6 | 4 | - | + | - | - | + |  + |
|   | 2 | 0 | 1 | 1 | + | + | + | - | + |  - |
|   | 3 | 2 | 6 | 4 | - | + | - | + | + |  + |
| 5 | 1 | 1 | 4 | 2 | + | + | - | - | + |  + |
|   | 2 | 0 | 1 | 1 | + | + | + | - | + |  - |
|   | 3 | 0 | 1 | 1 | + | + | + | - | + |  - |
|   | 4 | 0 | 1 | 1 | + | + | + | - | + |  - |
|   | 5 | 1 | 4 | 2 | + | + | - | + | + |  + |
|   | 6 | 0 | 1 | 1 | + | + | + | + | + |  - |
|   | 7 | 0 | 1 | 1 | + | + | + | + | + |  - |
----------------------------------------------

##  doc/tutorial.xml (127-150)
gap> tbls:= List( [ "Fi22", "2.Fi22", "3.Fi22", "6.Fi22" ],
>                 CharacterTable );;
gap> DisplayBlockInvariants( tbls, IsFaithful, true,
>      IsBlockWithCyclicDefectGroup, false,
>      IsBlockWithAbelianDefectGroup, [ true, fail ] );
Block invariants
faithful
noncyclic defect group

---------------------------------------------------
| G      | p |   b | d |  k |  l | a | n | r | sr |
---------------------------------------------------
| Fi22   | 5 |   1 | 2 | 20 | 16 | + | - | + |  + |
| 2.Fi22 | 2 |   3 | 2 |  4 |  1 | + | - | + |  + |
|        | 5 |  39 | 2 | 20 | 16 | + | - | + |  + |
| 3.Fi22 | 3 |   2 | 2 |  9 |  2 | + | - | + |  + |
|        |   |   3 | 2 |  9 |  2 | + | - | + |  + |
|        | 5 |  39 | 2 | 20 | 16 | + | - | - |  - |
|        |   |  40 | 2 | 20 | 16 | + | - | - |  - |
| 6.Fi22 | 5 | 107 | 2 | 20 | 16 | + | - | - |  - |
|        |   | 108 | 2 | 20 | 16 | + | - | - |  - |
---------------------------------------------------

##  doc/tutorial.xml (169-209)
gap> primes:= Union( List( tbls, t -> Set( Factors( Size( t ) ) ) ) );
[ 2, 3, 5, 7, 11, 13 ]
gap> for p in primes do
> DisplayBlockInvariants( tbls, IsFaithful, true,
>      IsBlockWithCyclicDefectGroup, false,
>      IsBlockWithAbelianDefectGroup, [ true, fail ],
>      UnderlyingCharacteristic, p,
>      rec( header:= [ "", Concatenation( "p = ", String( p ) ) ] ) );
> od;

p = 2

-------------------------------------------
| G      | b | d | k | l | a | n | r | sr |
-------------------------------------------
| 2.Fi22 | 3 | 2 | 4 | 1 | + | - | + |  + |
-------------------------------------------

p = 3

-------------------------------------------
| G      | b | d | k | l | a | n | r | sr |
-------------------------------------------
| 3.Fi22 | 2 | 2 | 9 | 2 | + | - | + |  + |
|        | 3 | 2 | 9 | 2 | + | - | + |  + |
-------------------------------------------

p = 5

-----------------------------------------------
| G      |   b | d |  k |  l | a | n | r | sr |
-----------------------------------------------
| Fi22   |   1 | 2 | 20 | 16 | + | - | + |  + |
| 2.Fi22 |  39 | 2 | 20 | 16 | + | - | + |  + |
| 3.Fi22 |  39 | 2 | 20 | 16 | + | - | - |  - |
|        |  40 | 2 | 20 | 16 | + | - | - |  - |
| 6.Fi22 | 107 | 2 | 20 | 16 | + | - | - |  - |
|        | 108 | 2 | 20 | 16 | + | - | - |  - |
-----------------------------------------------

##  doc/tutorial.xml (220-229)
gap> names:= [ "M11", "M12", "2.M12", "J1", "M22", "2.M22",
>     "3.M22", "4.M22", "6.M22", "12.M22", "J2", "2.J2",
>     "M23", "HS", "2.HS", "J3", "3.J3", "M24", "McL", "3.McL",
>     "He", "Ru", "2.Ru", "Suz", "2.Suz", "3.Suz", "6.Suz",
>     "ON", "3.ON", "Co3", "Co2", "Fi22", "2.Fi22", "3.Fi22",
>     "6.Fi22", "HN", "Ly", "Th", "Fi23", "Co1", "2.Co1",
>     "J4", "F3+", "3.F3+", "B", "2.B", "M" ];;
gap> tbls:= List( names, CharacterTable );;

##  doc/tutorial.xml (237-352)
gap> primes:= Union( List( tbls, t -> Set( Factors( Size( t ) ) ) ) );;
gap> for p in primes do
> DisplayBlockInvariants( tbls, IsFaithful, true,
>      IsBlockWithCyclicDefectGroup, false,
>      IsBlockWithAbelianDefectGroup, [ true, fail ],
>      UnderlyingCharacteristic, p,
>      rec( header:= [ "", Concatenation( "p = ", String( p ) ) ] ) );
> od;

p = 2

-------------------------------------------
| G      | b | d | k | l | a | n | r | sr |
-------------------------------------------
| M12    | 2 | 2 | 4 | 3 | + | - | + |  + |
| J1     | 1 | 3 | 8 | 5 | + | - | + |  + |
| J2     | 2 | 2 | 4 | 3 | + | - | + |  + |
| HS     | 2 | 2 | 4 | 3 | + | - | + |  + |
| Ru     | 2 | 2 | 4 | 3 | + | - | + |  + |
| Co3    | 2 | 3 | 8 | 5 | + | - | + |  + |
| 2.Fi22 | 3 | 2 | 4 | 1 | + | - | + |  + |
| F3+    | 2 | 2 | 4 | 3 | + | - | + |  + |
-------------------------------------------

p = 3

----------------------------------------------
| G      |  b | d |  k |  l | a | n | r | sr |
----------------------------------------------
| M11    |  1 | 2 |  9 |  7 | + | - | + |  + |
| M22    |  1 | 2 |  6 |  5 | + | - | + |  + |
| 2.M22  |  6 | 2 |  6 |  5 | + | - | + |  + |
| 3.M22  |  2 | 2 |  9 |  2 | + | - | + |  + |
| 4.M22  | 10 | 2 |  6 |  5 | + | - | - |  - |
|        | 11 | 2 |  6 |  5 | + | - | - |  - |
| 6.M22  |  7 | 2 |  9 |  2 | + | - | + |  + |
| M23    |  1 | 2 |  9 |  7 | + | - | + |  + |
| HS     |  1 | 2 |  9 |  7 | + | - | + |  + |
|        |  2 | 2 |  9 |  7 | + | - | + |  + |
| 2.HS   |  7 | 2 |  9 |  5 | + | - | + |  + |
| 3.J3   |  2 | 2 |  9 |  2 | + | - | + |  + |
| He     |  2 | 2 |  9 |  7 | + | - | + |  + |
| Suz    |  2 | 2 |  6 |  5 | + | - | + |  + |
| 3.Suz  |  3 | 2 |  9 |  2 | + | - | + |  + |
| ON     |  1 | 4 | 18 | 14 | + | - | + |  + |
|        |  2 | 2 |  6 |  5 | + | - | + |  + |
| 3.Fi22 |  2 | 2 |  9 |  2 | + | - | + |  + |
|        |  3 | 2 |  9 |  2 | + | - | + |  + |
| HN     |  2 | 2 |  9 |  7 | + | - | + |  + |
| Co1    |  3 | 2 |  9 |  5 | + | - | + |  + |
| J4     |  6 | 2 |  9 |  5 | + | - | + |  + |
| F3+    |  2 | 2 |  6 |  4 | + | - | + |  + |
| B      |  2 | 2 |  9 |  7 | + | - | + |  + |
|        |  3 | 2 |  9 |  7 | + | - | + |  + |
|        |  6 | 2 |  9 |  5 | + | - | + |  + |
----------------------------------------------

p = 5

-----------------------------------------------
| G      |   b | d |  k |  l | a | n | r | sr |
-----------------------------------------------
| J2     |   1 | 2 | 14 |  6 | + | - | + |  + |
| 2.J2   |   6 | 2 | 14 |  6 | + | - | + |  + |
| He     |   1 | 2 | 16 | 14 | + | - | + |  + |
| Suz    |   1 | 2 | 16 | 12 | + | - | + |  + |
| 2.Suz  |  19 | 2 | 16 | 12 | + | - | + |  + |
| 3.Suz  |  18 | 2 | 16 | 12 | + | - | - |  - |
|        |  19 | 2 | 16 | 12 | + | - | - |  - |
| 6.Suz  |  59 | 2 | 16 | 12 | + | - | - |  - |
|        |  60 | 2 | 16 | 12 | + | - | - |  - |
| Fi22   |   1 | 2 | 20 | 16 | + | - | + |  + |
| 2.Fi22 |  39 | 2 | 20 | 16 | + | - | + |  + |
| 3.Fi22 |  39 | 2 | 20 | 16 | + | - | - |  - |
|        |  40 | 2 | 20 | 16 | + | - | - |  - |
| 6.Fi22 | 107 | 2 | 20 | 16 | + | - | - |  - |
|        | 108 | 2 | 20 | 16 | + | - | - |  - |
| Fi23   |   1 | 2 | 20 | 16 | + | - | + |  + |
|        |   2 | 2 | 20 | 16 | + | - | + |  + |
| Co1    |   3 | 2 | 16 | 12 | + | - | + |  + |
| F3+    |   1 | 2 | 20 | 16 | + | - | + |  + |
|        |   2 | 2 | 16 | 14 | + | - | + |  + |
|        |   3 | 2 | 20 | 16 | + | - | + |  + |
| 3.F3+  |  45 | 2 | 20 | 16 | + | - | - |  - |
|        |  46 | 2 | 20 | 16 | + | - | - |  - |
|        |  47 | 2 | 20 | 14 | + | - | - |  - |
|        |  48 | 2 | 20 | 14 | + | - | - |  - |
| B      |   2 | 2 | 20 | 16 | + | - | + |  + |
|        |   8 | 2 | 20 | 16 | + | - | + |  + |
| M      |   4 | 2 | 20 | 16 | + | - | + |  + |
-----------------------------------------------

p = 7

---------------------------------------------
| G     |  b | d |  k |  l | a | n | r | sr |
---------------------------------------------
| Th    |  1 | 2 | 27 | 24 | + | - | + |  + |
| Co1   |  1 | 2 | 27 | 21 | + | - | + |  + |
| 2.Co1 | 46 | 2 | 27 | 21 | + | - | + |  + |
| B     |  1 | 2 | 27 | 24 | + | - | + |  + |
|       |  2 | 2 | 27 | 24 | + | - | + |  + |
|       |  4 | 2 | 27 | 21 | + | - | + |  + |
| 2.B   | 73 | 2 | 27 | 24 | + | - | + |  + |
| M     |  2 | 2 | 27 | 24 | + | - | + |  + |
---------------------------------------------

p = 11

----------------------------------------
| G | b | d |  k |  l | a | n | r | sr |
----------------------------------------
| M | 1 | 2 | 50 | 45 | + | - | + |  + |
----------------------------------------

##  doc/tutorial.xml (379-381)
gap> SetUserPreference( "AtlasRep", "DisplayFunction", origpref );

##  doc/tutorial.xml (406-417)
gap> b:= OnePBlock( AllCharacterTableNames(),
>            IsBlockWithAbelianDefectGroup, fail );
Block( CharacterTable( "Isoclinic(2x2.F4(2).2)" ), 2, 2 )
gap> Defect( b );
3
gap> dcl:= ClassPositionsOfDefectGroupOfBlock( b );
[ 1, 2, 3, 4, 215, 216 ]
gap> t:= UnderlyingCharacterTable( b );;
gap> OrdersClassRepresentatives( t ){ dcl };
[ 1, 4, 2, 4, 2, 4 ]

##  doc/tutorial.xml (440-446)
gap> b:= OnePBlock( AllCharacterTableNames( IsSimple, true ),
>            IsBlockWithAbelianDefectGroup, fail );
Block( CharacterTable( "L8(2)" ), 3, 5 )
gap> Defect( b );
3

##  doc/tutorial.xml (486-502)
gap> g:= DihedralGroup( 24 );;
gap> p:= 2;;
gap> t:= CharacterTable( g );;
gap> h:= PCore( g, 2 );;
gap> Size( h );
4
gap> s:= CharacterTable( h );;
gap> AlperinBurryCorrespondent( s, t, p, 1 );
fail
gap> BrauerCorrespondent( s, t, p, 1 );
1
gap> PRegularCorrespondent( s, t, p, 1 );
1
gap> WheelerCorrespondent( s, t, p, 1 );
1

##  doc/tutorial.xml (514-528)
gap> g:= SymmetricGroup( 3 );;
gap> p:= 2;;
gap> t:= CharacterTable( g );;
gap> h:= TrivialSubgroup( g );;
gap> s:= CharacterTable( h );;
gap> AlperinBurryCorrespondent( s, t, p, 1 );
fail
gap> BrauerCorrespondent( s, t, p, 1 );
fail
gap> PRegularCorrespondent( s, t, p, 1 );
1
gap> WheelerCorrespondent( s, t, p, 1 );
1

##  doc/tutorial.xml (540-554)
gap> g:= AlternatingGroup( 4 );;
gap> p:= 2;;
gap> t:= CharacterTable( g );;
gap> h:= SylowSubgroup( g, 3 );;
gap> s:= CharacterTable( h );;
gap> AlperinBurryCorrespondent( s, t, p, 1 );
1
gap> BrauerCorrespondent( s, t, p, 1 );
fail
gap> PRegularCorrespondent( s, t, p, 1 );
fail
gap> WheelerCorrespondent( s, t, p, 1 );
1

##  doc/tutorial.xml (566-580)
gap> g:= CyclicGroup( 2 );;
gap> p:= 2;;
gap> t:= CharacterTable( g );;
gap> h:= TrivialSubgroup( g );;
gap> s:= CharacterTable( h );;
gap> AlperinBurryCorrespondent( s, t, p, 1 );
1
gap> BrauerCorrespondent( s, t, p, 1 );
fail
gap> PRegularCorrespondent( s, t, p, 1 );
1
gap> WheelerCorrespondent( s, t, p, 1 );
1

##  doc/tutorial.xml (593-610)
gap> g:= PSL(2,7);;
gap> Size( g );  IsSimple( g );
168
true
gap> p:= 3;;
gap> t:= CharacterTable( g );;
gap> h:= SylowSubgroup( g, 2 );;
gap> s:= CharacterTable( h );;
gap> AlperinBurryCorrespondent( s, t, p, 1 );
fail
gap> BrauerCorrespondent( s, t, p, 1 );
fail
gap> PRegularCorrespondent( s, t, p, 1 );
fail
gap> WheelerCorrespondent( s, t, p, 1 );
4

##  doc/tutorial.xml (635-669)
gap> tom:= TableOfMarks( "M11" );;
gap> g:= UnderlyingGroup( tom );;
gap> p:= 2;;
gap> good:= [];;
gap> bad:= [];;
gap> for i in [ 1 .. Length( OrdersTom( tom ) ) - 1 ] do
>   h:= RepresentativeTom( tom, i );
>   tblh:= CharacterTable( h );
>   for b in [ 1 .. Length( PrimeBlocks( tblh, p ).defect ) ] do
>     if BrauerCorrespondent( tblh, CharacterTable( g ), p, b ) <> fail then
>       AddSet( good, [ Size( h ), b ] );
>     else
>       AddSet( bad, [ Size( h ), b ] );
>     fi;
>   od;
> od;
gap> good;
[ [ 2, 1 ], [ 4, 1 ], [ 6, 1 ], [ 8, 1 ], [ 10, 1 ], [ 12, 1 ], 
  [ 16, 1 ], [ 18, 1 ], [ 20, 1 ], [ 24, 1 ], [ 36, 1 ], [ 48, 1 ], 
  [ 60, 1 ], [ 72, 1 ], [ 120, 1 ], [ 144, 1 ], [ 360, 1 ], 
  [ 660, 1 ], [ 720, 1 ] ]
gap> bad;
[ [ 1, 1 ], [ 3, 1 ], [ 3, 2 ], [ 3, 3 ], [ 5, 1 ], [ 5, 2 ], 
  [ 5, 3 ], [ 5, 4 ], [ 5, 5 ], [ 6, 2 ], [ 6, 3 ], [ 9, 1 ], 
  [ 9, 2 ], [ 9, 3 ], [ 9, 4 ], [ 9, 5 ], [ 9, 6 ], [ 9, 7 ], 
  [ 9, 8 ], [ 9, 9 ], [ 10, 2 ], [ 10, 3 ], [ 11, 1 ], [ 11, 2 ], 
  [ 11, 3 ], [ 11, 4 ], [ 11, 5 ], [ 11, 6 ], [ 11, 7 ], [ 11, 8 ], 
  [ 11, 9 ], [ 11, 10 ], [ 11, 11 ], [ 12, 2 ], [ 18, 2 ], [ 18, 3 ], 
  [ 18, 4 ], [ 18, 5 ], [ 18, 6 ], [ 20, 2 ], [ 36, 2 ], [ 36, 3 ], 
  [ 36, 4 ], [ 55, 1 ], [ 55, 2 ], [ 55, 3 ], [ 55, 4 ], [ 55, 5 ], 
  [ 55, 6 ], [ 55, 7 ], [ 60, 2 ], [ 72, 2 ], [ 72, 3 ], [ 120, 2 ], 
  [ 144, 2 ], [ 360, 2 ], [ 360, 3 ], [ 660, 2 ], [ 660, 3 ], 
  [ 660, 4 ], [ 720, 2 ] ]

##  doc/tutorial.xml (679-694)
gap> tom:= TableOfMarks( "M12" );;
gap> g:= UnderlyingGroup( tom );;
gap> p:= 2;;
gap> results:= [];;
gap> for i in Positions( OrdersTom( tom ), 6 ) do
>   h:= RepresentativeTom( tom, i );
>   if IsCyclic( h ) then
>     tblh:= CharacterTable( h );
>     Add( results, List( [ 1 .. Length( PrimeBlocks( tblh, p ).defect ) ],
>            b -> BrauerCorrespondent( tblh, CharacterTable( g ), p, b ) ) );
>   fi;
> od;
gap> results;
[ [ 1, fail, fail ], [ fail, 2, 2 ] ]

##  doc/tutorial.xml (720-743)
gap> names:= AllCharacterTableNames( IsSporadicSimple, true,
>                IsDuplicateTable, false );
[ "B", "Co1", "Co2", "Co3", "F3+", "Fi22", "Fi23", "HN", "HS", "He", 
  "J1", "J2", "J3", "J4", "Ly", "M", "M11", "M12", "M22", "M23", 
  "M24", "McL", "ON", "Ru", "Suz", "Th" ]
gap> for name in names do
>      t:= CharacterTable( name );
>      test:= Filtered( [ 1 .. NrConjugacyClasses( t ) ],
>                       i -> IsRealClass( t, i )
>                            and not IsStronglyRealClass( t, i ) );
>      if test <> [] then
>        Print( name, ":  ", ClassNames( t, "Atlas" ){ test }, "\n" );
>      fi;
>    od;
Co2:  [ "16B" ]
HN:  [ "8A" ]
M:  [ "8C", "8F", "24F", "24G", "24H", "24J", "32A", "32B", "40A", 
  "48A" ]
M22:  [ "8A" ]
M23:  [ "8A" ]
McL:  [ "3A", "5A", "6A", "8A", "10A", "12A" ]
Th:  [ "8B" ]

##  doc/tutorial.xml (767-780)
gap> t:= CharacterTable( "McL" );
CharacterTable( "McL" )
gap> orders:= OrdersClassRepresentatives( t );
[ 1, 2, 3, 3, 4, 5, 5, 6, 6, 7, 7, 8, 9, 9, 10, 11, 11, 12, 14, 14, 
  15, 15, 30, 30 ]
gap> nccl:= Length( orders );
24
gap> Filtered( [ 1 .. nccl ],
>        i -> ClassMultiplicationCoefficient( t, 2, 2, i ) <> 0 );
[ 1, 2, 4, 5, 7, 9 ]
gap> Filtered( [ 1 .. nccl ], i -> PowerMap( t, -1, i ) = i );
[ 1, 2, 3, 4, 5, 6, 7, 8, 9, 12, 15, 18 ]

##  doc/tutorial.xml (787-797)
gap> t:= CharacterTable( "Fi23" );
CharacterTable( "Fi23" )
gap> orders:= OrdersClassRepresentatives( t );;
gap> filt:= PositionsProperty( orders, x -> x in [ 16, 22, 23 ] );
[ 63, 64, 77, 78, 79, 80, 81 ]
gap> PowerMap( t, -1 ){ filt };
[ 64, 63, 77, 79, 78, 81, 80 ]
gap> ClassNames( t, "Atlas" ){ filt };
[ "16A", "16B", "22A", "22B", "22C", "23A", "23B" ]

##  doc/tutorial.xml (818-827)
gap> names:= AllCharacterTableNames( IsSporadicSimple, true,
>                IsDuplicateTable, false );
[ "B", "Co1", "Co2", "Co3", "F3+", "Fi22", "Fi23", "HN", "HS", "He", 
  "J1", "J2", "J3", "J4", "Ly", "M", "M11", "M12", "M22", "M23", 
  "M24", "McL", "ON", "Ru", "Suz", "Th" ]
gap> bl:= AllPBlocks( names, IsRealBlock, true,
>             IsStronglyRealBlock, false );
[ Block( CharacterTable( "McL" ), 2, 4 ) ]

##  doc/tutorial.xml (836-848)
gap> Defect( bl[1] );
1
gap> dcl:= ClassPositionsOfDefectClasses( bl[1] );
[ 6, 10, 11, 21, 22 ]
gap> tbl:= UnderlyingCharacterTable( bl[1] );;
gap> ClassNames( tbl, "Atlas" ){ dcl };
[ "5A", "7A", "7B", "15A", "15B" ]
gap> Filtered( dcl, c -> IsRealClass( tbl, c ) );
[ 6 ]
gap> Filtered( dcl, c -> IsStronglyRealClass( tbl, c ) );
[  ]

##  doc/tutorial.xml (888-916)
gap> DimensionsOfRadicalPowers:= function( A, J )
>     local l, Jpower;
> 
>     l:= [ Dimension( J ) ];
>     Jpower:= J;
>     while Dimension( Jpower ) <> 0 do
>       Jpower:= ProductSpace( Jpower, J );
>       Add( l, Dimension( Jpower ) );
>     od;
> 
>     return l;
> end;;
gap> DimensionsOfLoewyLayers:= function( A, J )
>     local dims, l, i;
> 
>     if Dimension( A ) = 0 then
>       return [];
>     fi;
> 
>     dims:= DimensionsOfRadicalPowers( A, J );
>     l:= [ Dimension( A ) - dims[1] ];
>     for i in [ 2 .. Length( dims ) ] do
>       l[i]:= dims[ i-1 ] - dims[i];
>     od;
> 
>     return l;
> end;;

##  doc/tutorial.xml (959-972)
gap> RadicalOfIndecomposableGroupAlgebra:= function( A, tbl )
>     local radgens, gens, classlengths, i;
> 
>     radgens:= [];
>     gens:= BasisVectors( CanonicalBasis( A ) );
>     classlengths:= SizesConjugacyClasses( tbl );
>     for i in [ 2 .. Length( gens ) ] do
>       Add( radgens, gens[i] - classlengths[i] * gens[1] );
>     od;
> 
>     return SubalgebraNC( A, radgens, "basis" );
> end;;

##  doc/tutorial.xml (982-997)
gap> DimensionsOfLoewyLayersByTable:= function( tbl, p )
>      local A, J;
> 
>      if Length( PrimeBlocks( tbl, p ).defect ) = 1 then
>          # The group algebra is indecomposable.
>          A:= SCAlgebraCentreOfGroupAlgebra( tbl, p );
>          J:= RadicalOfIndecomposableGroupAlgebra( A, tbl );
>        else
>          # Use the simpleminded variant.
>          A:= SCAlgebraCentreOfBlock( tbl, p, 1 );
>          J:= RadicalOfAlgebra( A );
>        fi;
>        return DimensionsOfLoewyLayers( A, J );
> end;;

##  doc/tutorial.xml (1014-1246)
gap> conjecture_is_wrong_for:= [];;
gap> conjecture_is_open_for:= [];;
gap> names:= AllCharacterTableNames( IsSporadicSimple, true,
>                IsDuplicateTable, false : OrderedBy:= Size );
[ "M11", "M12", "J1", "M22", "J2", "M23", "HS", "J3", "M24", "McL", 
  "He", "Ru", "Suz", "ON", "Co3", "Co2", "Fi22", "HN", "Ly", "Th", 
  "Fi23", "Co1", "J4", "F3+", "B", "M" ]
gap> for name in names do
>      Print( name, ":\n" );
>      t:= CharacterTable( name );
>      for p in Set( Factors( Size( t ) ) ) do
>        dimst:= DimensionsOfLoewyLayersByTable( t, p );
>        Print( "  ", String( p, 2 ), ":  ", String( dimst, -30 ) );
>        nname:= Concatenation( name, "N", String( p ) );
>        n:= CharacterTable( nname );
>        if n = fail then
>          Print( "(no Sylow normalizer table)\n" );
>          Add( conjecture_is_open_for, [ name, p ] );
>        else
>          dimsn:= DimensionsOfLoewyLayersByTable( n, p );
>          if dimsn = dimst then
>            Print( "same dimensions for G and N_G(P)\n" );
>          else
>            Print( dimsn, "\n" );
>          fi;
>          # Check the conjecture.
>          if Length( dimst ) < Length( dimsn ) then
>            Add( conjecture_is_wrong_for, [ name, p ] );
>          fi;
>        fi;
>      od;
>    od;
M11:
   2:  [ 1, 3, 2, 1, 1 ]             [ 1, 4, 1, 1 ]
   3:  [ 1, 7, 1 ]                   same dimensions for G and N_G(P)
   5:  [ 1, 4 ]                      same dimensions for G and N_G(P)
  11:  [ 1, 5, 1 ]                   same dimensions for G and N_G(P)
M12:
   2:  [ 1, 7, 2, 1 ]                [ 1, 14, 1 ]
   3:  [ 1, 8, 2 ]                   [ 1, 9, 1 ]
   5:  [ 1, 4 ]                      same dimensions for G and N_G(P)
  11:  [ 1, 5, 1 ]                   same dimensions for G and N_G(P)
J1:
   2:  [ 1, 7 ]                      same dimensions for G and N_G(P)
   3:  [ 1, 2 ]                      same dimensions for G and N_G(P)
   5:  [ 1, 2, 1 ]                   same dimensions for G and N_G(P)
   7:  [ 1, 6 ]                      same dimensions for G and N_G(P)
  11:  [ 1, 10 ]                     same dimensions for G and N_G(P)
  19:  [ 1, 6, 1, 1 ]                same dimensions for G and N_G(P)
M22:
   2:  [ 1, 9, 2 ]                   [ 1, 16 ]
   3:  [ 1, 5 ]                      same dimensions for G and N_G(P)
   5:  [ 1, 4 ]                      same dimensions for G and N_G(P)
   7:  [ 1, 3, 1 ]                   same dimensions for G and N_G(P)
  11:  [ 1, 5, 1 ]                   same dimensions for G and N_G(P)
J2:
   2:  [ 1, 12, 3, 1 ]               [ 1, 12, 6 ]
   3:  [ 1, 8, 4 ]                   [ 1, 9, 3 ]
   5:  [ 1, 4, 5, 3, 1 ]             same dimensions for G and N_G(P)
   7:  [ 1, 6 ]                      same dimensions for G and N_G(P)
M23:
   2:  [ 1, 12, 2 ]                  [ 1, 16 ]
   3:  [ 1, 7, 1 ]                   same dimensions for G and N_G(P)
   5:  [ 1, 4 ]                      same dimensions for G and N_G(P)
   7:  [ 1, 3, 1 ]                   same dimensions for G and N_G(P)
  11:  [ 1, 5, 1 ]                   same dimensions for G and N_G(P)
  23:  [ 1, 11, 1 ]                  same dimensions for G and N_G(P)
HS:
   2:  [ 1, 13, 4, 1, 1 ]            [ 1, 30, 4 ]
   3:  [ 1, 7, 1 ]                   same dimensions for G and N_G(P)
   5:  [ 1, 13, 3 ]                  [ 1, 14, 2 ]
   7:  [ 1, 6 ]                      same dimensions for G and N_G(P)
  11:  [ 1, 5, 1 ]                   same dimensions for G and N_G(P)
J3:
   2:  [ 1, 12, 3, 1 ]               [ 1, 12, 6 ]
   3:  [ 1, 15 ]                     same dimensions for G and N_G(P)
   5:  [ 1, 2, 1 ]                   same dimensions for G and N_G(P)
  17:  [ 1, 8, 1 ]                   same dimensions for G and N_G(P)
  19:  [ 1, 9, 1 ]                   same dimensions for G and N_G(P)
M24:
   2:  [ 1, 18, 5, 1, 1 ]            [ 1, 54, 6 ]
   3:  [ 1, 9, 3 ]                   [ 1, 10, 2 ]
   5:  [ 1, 4 ]                      same dimensions for G and N_G(P)
   7:  [ 1, 3, 1 ]                   same dimensions for G and N_G(P)
  11:  [ 1, 10 ]                     same dimensions for G and N_G(P)
  23:  [ 1, 11, 1 ]                  same dimensions for G and N_G(P)
McL:
   2:  [ 1, 12, 4, 1 ]               [ 1, 16 ]
   3:  [ 1, 15, 4, 1 ]               [ 1, 16, 4 ]
   5:  [ 1, 14, 4 ]                  [ 1, 15, 3 ]
   7:  [ 1, 3, 1 ]                   same dimensions for G and N_G(P)
  11:  [ 1, 5, 1 ]                   same dimensions for G and N_G(P)
He:
   2:  [ 1, 18, 5, 1, 1 ]            [ 1, 54, 6 ]
   3:  [ 1, 9, 3 ]                   [ 1, 10, 2 ]
   5:  [ 1, 14, 1 ]                  same dimensions for G and N_G(P)
   7:  [ 1, 19, 3 ]                  [ 1, 21, 1 ]
  17:  [ 1, 8, 1 ]                   same dimensions for G and N_G(P)
Ru:
   2:  [ 1, 30, 1 ]                  [ 1, 83, 1 ]
   3:  [ 1, 9, 4 ]                   [ 1, 10, 3 ]
   5:  [ 1, 20, 4 ]                  [ 1, 21, 3 ]
   7:  [ 1, 6 ]                      same dimensions for G and N_G(P)
  13:  [ 1, 12 ]                     same dimensions for G and N_G(P)
  29:  [ 1, 14, 1 ]                  same dimensions for G and N_G(P)
Suz:
   2:  [ 1, 26, 9, 1, 1 ]            [ 1, 59, 21 ]
   3:  [ 1, 22, 8, 2, 1 ]            [ 1, 24, 11, 3 ]
   5:  [ 1, 10, 5 ]                  same dimensions for G and N_G(P)
   7:  [ 1, 6 ]                      same dimensions for G and N_G(P)
  11:  [ 1, 10 ]                     same dimensions for G and N_G(P)
  13:  [ 1, 6, 1 ]                   same dimensions for G and N_G(P)
ON:
   2:  [ 1, 16, 2, 1 ]               [ 1, 27, 4 ]
   3:  [ 1, 14, 3 ]                  same dimensions for G and N_G(P)
   5:  [ 1, 4 ]                      same dimensions for G and N_G(P)
   7:  [ 1, 20, 3 ]                  [ 1, 21, 2 ]
  11:  [ 1, 10 ]                     same dimensions for G and N_G(P)
  19:  [ 1, 6, 1, 1 ]                same dimensions for G and N_G(P)
  31:  [ 1, 15, 1 ]                  same dimensions for G and N_G(P)
Co3:
   2:  [ 1, 16, 11, 3, 1 ]           [ 1, 49, 11 ]
   3:  [ 1, 28, 8, 2 ]               [ 1, 35, 15, 1 ]
   5:  [ 1, 20, 5 ]                  [ 1, 21, 4 ]
   7:  [ 1, 6 ]                      same dimensions for G and N_G(P)
  11:  [ 1, 5, 1 ]                   same dimensions for G and N_G(P)
  23:  [ 1, 11, 1 ]                  same dimensions for G and N_G(P)
Co2:
   2:  [ 1, 36, 16, 4, 1, 1 ]        [ 1, 310, 82, 1 ]
   3:  [ 1, 24, 16, 5, 1 ]           [ 1, 30, 12, 2 ]
   5:  [ 1, 21, 5 ]                  [ 1, 22, 4 ]
   7:  [ 1, 6 ]                      same dimensions for G and N_G(P)
  11:  [ 1, 10 ]                     same dimensions for G and N_G(P)
  23:  [ 1, 11, 1 ]                  same dimensions for G and N_G(P)
Fi22:
   2:  [ 1, 38, 14, 6, 1, 1, 1 ]     [ 1, 188, 24, 2 ]
   3:  [ 1, 31, 17, 7, 1, 1 ]        [ 1, 93, 9 ]
   5:  [ 1, 13, 6 ]                  same dimensions for G and N_G(P)
   7:  [ 1, 6 ]                      same dimensions for G and N_G(P)
  11:  [ 1, 5, 1 ]                   same dimensions for G and N_G(P)
  13:  [ 1, 6, 1 ]                   same dimensions for G and N_G(P)
HN:
   2:  [ 1, 36, 7, 1 ]               [ 1, 58, 15 ]
   3:  [ 1, 24, 7, 1 ]               [ 1, 23, 6 ]
   5:  [ 1, 34, 9, 1 ]               [ 1, 64, 3 ]
   7:  [ 1, 6 ]                      same dimensions for G and N_G(P)
  11:  [ 1, 10 ]                     same dimensions for G and N_G(P)
  19:  [ 1, 9, 1 ]                   same dimensions for G and N_G(P)
Ly:
   2:  [ 1, 13, 8, 3 ]               [ 1, 20, 1 ]
   3:  [ 1, 29, 9, 2, 1 ]            [ 1, 30, 16, 4 ]
   5:  [ 1, 39, 7, 1 ]               [ 1, 52, 5 ]
   7:  [ 1, 6 ]                      same dimensions for G and N_G(P)
  11:  [ 1, 5, 1 ]                   same dimensions for G and N_G(P)
  31:  [ 1, 6, 1, 1, 1, 1 ]          same dimensions for G and N_G(P)
  37:  [ 1, 18, 1 ]                  same dimensions for G and N_G(P)
  67:  [ 1, 22, 1, 1 ]               same dimensions for G and N_G(P)
Th:
   2:  [ 1, 41, 3 ]                  [ 1, 88 ]
   3:  [ 1, 38, 2 ]                  [ 1, 69, 3 ]
   5:  [ 1, 21, 5 ]                  [ 1, 22, 4 ]
   7:  [ 1, 23, 3 ]                  same dimensions for G and N_G(P)
  13:  [ 1, 12 ]                     same dimensions for G and N_G(P)
  19:  [ 1, 18 ]                     same dimensions for G and N_G(P)
  31:  [ 1, 15, 1 ]                  same dimensions for G and N_G(P)
Fi23:
   2:  [ 1, 48, 25, 7, 4, 2, 1, 1 ]  [ 1, 152, 141, 23, 2 ]
   3:  [ 1, 51, 28, 9, 3, 1, 1 ]     [ 1, 230, 58, 3 ]
   5:  [ 1, 13, 6 ]                  same dimensions for G and N_G(P)
   7:  [ 1, 6 ]                      same dimensions for G and N_G(P)
  11:  [ 1, 10 ]                     same dimensions for G and N_G(P)
  13:  [ 1, 6, 1 ]                   same dimensions for G and N_G(P)
  17:  [ 1, 16 ]                     same dimensions for G and N_G(P)
  23:  [ 1, 11, 1 ]                  same dimensions for G and N_G(P)
Co1:
   2:  [ 1, 64, 27, 2, 1, 1 ]        (no Sylow normalizer table)
   3:  [ 1, 36, 25, 10, 1, 1 ]       [ 1, 73, 35, 19 ]
   5:  [ 1, 23, 14, 7 ]              [ 1, 26, 9, 1 ]
   7:  [ 1, 12, 14 ]                 same dimensions for G and N_G(P)
  11:  [ 1, 10 ]                     same dimensions for G and N_G(P)
  13:  [ 1, 12 ]                     same dimensions for G and N_G(P)
  23:  [ 1, 11, 1 ]                  same dimensions for G and N_G(P)
J4:
   2:  [ 1, 51, 6, 1 ]               (no Sylow normalizer table)
   3:  [ 1, 9, 4 ]                   [ 1, 10, 3 ]
   5:  [ 1, 4 ]                      same dimensions for G and N_G(P)
   7:  [ 1, 3, 1 ]                   same dimensions for G and N_G(P)
  11:  [ 1, 43, 5 ]                  [ 1, 44, 4 ]
  23:  [ 1, 22 ]                     same dimensions for G and N_G(P)
  29:  [ 1, 28 ]                     same dimensions for G and N_G(P)
  31:  [ 1, 10, 1, 1 ]               same dimensions for G and N_G(P)
  37:  [ 1, 12, 1, 1 ]               same dimensions for G and N_G(P)
  43:  [ 1, 14, 1, 1 ]               same dimensions for G and N_G(P)
F3+:
   2:  [ 1, 71, 20, 4, 1 ]           (no Sylow normalizer table)
   3:  [ 1, 72, 24, 4 ]              (no Sylow normalizer table)
   5:  [ 1, 13, 6 ]                  same dimensions for G and N_G(P)
   7:  [ 1, 26, 4 ]                  [ 1, 27, 3 ]
  11:  [ 1, 10 ]                     same dimensions for G and N_G(P)
  13:  [ 1, 12 ]                     same dimensions for G and N_G(P)
  17:  [ 1, 16 ]                     same dimensions for G and N_G(P)
  23:  [ 1, 11, 1 ]                  same dimensions for G and N_G(P)
  29:  [ 1, 14, 1 ]                  same dimensions for G and N_G(P)
B:
   2:  [ 1, 140, 30, 7, 1 ]          (no Sylow normalizer table)
   3:  [ 1, 81, 41, 13, 4, 1, 1 ]    [ 1, 230, 58, 3 ]
   5:  [ 1, 56, 18, 4 ]              [ 1, 52, 5 ]
   7:  [ 1, 23, 3 ]                  same dimensions for G and N_G(P)
  11:  [ 1, 10 ]                     (no Sylow normalizer table)
  13:  [ 1, 12 ]                     (no Sylow normalizer table)
  17:  [ 1, 16 ]                     (no Sylow normalizer table)
  19:  [ 1, 18 ]                     (no Sylow normalizer table)
  23:  [ 1, 11, 1 ]                  (no Sylow normalizer table)
  31:  [ 1, 15, 1 ]                  same dimensions for G and N_G(P)
  47:  [ 1, 23, 1 ]                  (no Sylow normalizer table)
M:
   2:  [ 1, 169, 12, 1 ]             (no Sylow normalizer table)
   3:  [ 1, 147, 14, 2, 1 ]          (no Sylow normalizer table)
   5:  [ 1, 106, 17, 4, 1 ]          [ 1, 159, 37, 4 ]
   7:  [ 1, 81, 9, 1 ]               [ 1, 82, 17 ]
  11:  [ 1, 39, 10 ]                 same dimensions for G and N_G(P)
  13:  [ 1, 56, 5 ]                  [ 1, 57, 4 ]
  17:  [ 1, 16 ]                     (no Sylow normalizer table)
  19:  [ 1, 18 ]                     (no Sylow normalizer table)
  23:  [ 1, 11, 1 ]                  (no Sylow normalizer table)
  29:  [ 1, 28 ]                     (no Sylow normalizer table)
  31:  [ 1, 15, 1 ]                  (no Sylow normalizer table)
  41:  [ 1, 40 ]                     (no Sylow normalizer table)
  47:  [ 1, 23, 1 ]                  same dimensions for G and N_G(P)
  59:  [ 1, 29, 1 ]                  (no Sylow normalizer table)
  71:  [ 1, 35, 1 ]                  (no Sylow normalizer table)

##  doc/tutorial.xml (1270-1279)
gap> conjecture_is_wrong_for;
[  ]
gap> conjecture_is_open_for;
[ [ "Co1", 2 ], [ "J4", 2 ], [ "F3+", 2 ], [ "F3+", 3 ], [ "B", 2 ], 
  [ "B", 11 ], [ "B", 13 ], [ "B", 17 ], [ "B", 19 ], [ "B", 23 ], 
  [ "B", 47 ], [ "M", 2 ], [ "M", 3 ], [ "M", 17 ], [ "M", 19 ], 
  [ "M", 23 ], [ "M", 29 ], [ "M", 31 ], [ "M", 41 ], [ "M", 59 ], 
  [ "M", 71 ] ]

##  doc/tutorial.xml (1290-1296)
gap> defectone:= Filtered( conjecture_is_open_for,
>        pair -> Size( CharacterTable( pair[1] ) ) mod pair[2]^2 <> 0 );
[ [ "B", 11 ], [ "B", 13 ], [ "B", 17 ], [ "B", 19 ], [ "B", 23 ], 
  [ "B", 47 ], [ "M", 17 ], [ "M", 19 ], [ "M", 23 ], [ "M", 29 ], 
  [ "M", 31 ], [ "M", 41 ], [ "M", 59 ], [ "M", 71 ] ]

##  doc/tutorial.xml (1395-1478)
gap> # G = B, p = 11
gap> DimensionsOfLoewyLayersByTable(
>        CharacterTable( "P:Q", [ 11, 10 ] ) *
>        CharacterTable( "S5" ), 11 );
[ 1, 10 ]
gap> # G = B, p = 13
gap> DimensionsOfLoewyLayersByTable(
>        CharacterTable( "P:Q", [ 13, 12 ] ) *
>        CharacterTable( "S4" ), 13 );
[ 1, 12 ]
gap> # G = B, p = 17
gap> tblH1:= CharacterTable( "17:8" );;
gap> tblG1:= CharacterTable( "17:16" );;
gap> tblH2:= CharacterTable( "2^2" );;
gap> tblG2:= CharacterTable( "D8" );;
gap> DimensionsOfLoewyLayersByTable(
>        CharacterTableOfIndexTwoSubdirectProduct(
>            tblH1, tblG1, tblH2, tblG2, "(17:8x2^2).2" ).table, 17 );
[ 1, 16 ]
gap> # G = B, p = 19
gap> DimensionsOfLoewyLayersByTable(
>        CharacterTable( "P:Q", [ 19, 18 ] ) *
>        CharacterTable( "C2" ), 19 );
[ 1, 18 ]
gap> # G = B, p = 23
gap> DimensionsOfLoewyLayersByTable(
>        CharacterTable( "P:Q", [ 23, 11 ] ) *
>        CharacterTable( "C2" ), 23 );
[ 1, 11, 1 ]
gap> # G = B, p = 47
gap> DimensionsOfLoewyLayersByTable(
>        CharacterTable( "P:Q", [ 47, 23 ] ), 47 );
[ 1, 23, 1 ]
gap> # G = M, p = 17
gap> tblH1:= CharacterTable( "17:8" );;
gap> tblG1:= CharacterTable( "17:16" );;
gap> tblH2:= CharacterTable( "L3(2)" );;
gap> tblG2:= CharacterTable( "L3(2).2" );;
gap> DimensionsOfLoewyLayersByTable(
>        CharacterTableOfIndexTwoSubdirectProduct(
>            tblH1, tblG1, tblH2, tblG2, "(17:8xL3(2)).2" ).table, 17 );
[ 1, 16 ]
gap> # G = M, p = 19
gap> tblH1:= CharacterTable( "19:9" );;
gap> tblG1:= CharacterTable( "19:18" );;
gap> tblH2:= CharacterTable( "A5" );;
gap> tblG2:= CharacterTable( "S5" );;
gap> DimensionsOfLoewyLayersByTable(
>        CharacterTableOfIndexTwoSubdirectProduct(
>            tblH1, tblG1, tblH2, tblG2, "(19:9xA5).2" ).table, 19 );
[ 1, 18 ]
gap> # G = M, p = 23
gap> DimensionsOfLoewyLayersByTable(
>        CharacterTable( "P:Q", [ 23, 11 ] ) *
>        CharacterTable( "S4" ), 23 );
[ 1, 11, 1 ]
gap> # G = M, p = 29
gap> tblH1:= CharacterTable( "29:14" );;
gap> tblG1:= CharacterTable( "29:28" );;
gap> tblH2:= CharacterTable( "C3" );;
gap> tblG2:= CharacterTable( "S3" );;
gap> DimensionsOfLoewyLayersByTable(
>        CharacterTableOfIndexTwoSubdirectProduct(
>            tblH1, tblG1, tblH2, tblG2, "(29:14x3).2" ).table, 29 );
[ 1, 28 ]
gap> # G = M, p = 31
gap> DimensionsOfLoewyLayersByTable(
>        CharacterTable( "P:Q", [ 31, 15 ] ) *
>        CharacterTable( "S3" ), 31 );
[ 1, 15, 1 ]
gap> # G = M, p = 41
gap> DimensionsOfLoewyLayersByTable(
>        CharacterTable( "P:Q", [ 41, 40 ] ), 41 );
[ 1, 40 ]
gap> # G = M, p = 59
gap> DimensionsOfLoewyLayersByTable(
>        CharacterTable( "P:Q", [ 59, 29 ] ), 59 );
[ 1, 29, 1 ]
gap> # G = M, p = 71
gap> DimensionsOfLoewyLayersByTable(
>        CharacterTable( "P:Q", [ 71, 35 ] ), 71 );
[ 1, 35, 1 ]

##  doc/tutorial.xml (1516-1521)
gap> hard:= Filtered( conjecture_is_open_for,
>        pair -> Size( CharacterTable( pair[1] ) ) mod pair[2]^2 = 0 );
[ [ "Co1", 2 ], [ "J4", 2 ], [ "F3+", 2 ], [ "F3+", 3 ], [ "B", 2 ], 
  [ "M", 2 ], [ "M", 3 ] ]

##  doc/tutorial.xml (1684-1702)
gap> g1:= AtlasGroup( "Fi24'" );;
gap> s1:= SylowSubgroup( g1, 2 );;
gap> pc1:= Image( IsomorphismPcGroup( s1 ) );
gap> j4:= CharacterTable( "J4" );;
gap> j4m1:= CharacterTable( Maxes( j4 )[1] );;
gap> ( Size( j4 ) / Size( j4m1 ) ) mod 2;
1
gap> GroupInfoForCharacterTable( j4m1 );
[ [ "AtlasSubgroup", [ "J4", 1 ] ], 
  [ "PrimitiveGroup", [ 2048, 11 ] ] ]
gap> g2:= PrimitiveGroup( 2048, 11 );;
gap> s2:= SylowSubgroup( g2, 2 );;
gap> pc2:= Image( IsomorphismPcGroup( s2 ) );;
gap> Collected( Factors( Size( pc1 ) ) );
[ [ 2, 21 ] ]
gap> Size( pc1 ) = Size( pc2 );
true

##  doc/tutorial.xml (1714-1731)
gap> IsPGroup( pc1 );;  IsPGroup( pc2 );;
gap> t1:= CharacterTable( pc1 );;
gap> irr1:= Irr( t1 );;
gap> t2:= CharacterTable( pc2 );;
gap> irr2:= Irr( t2 );;
gap> deg:= CharacterDegrees( t1 );
[ [ 1, 32 ], [ 2, 56 ], [ 4, 80 ], [ 8, 84 ], [ 16, 109 ], [ 32, 70 ],
  [ 64, 94 ], [ 128, 42 ], [ 256, 14 ] ]
gap> deg = CharacterDegrees( t2 );
true
gap> IsRecord( TransformingPermutations( irr1, irr2 ) );
true
gap> Collected( OrdersClassRepresentatives( t1 ) );
[ [ 1, 1 ], [ 2, 98 ], [ 4, 394 ], [ 8, 87 ], [ 16, 1 ] ]
gap> Collected( OrdersClassRepresentatives( t2 ) );
[ [ 1, 1 ], [ 2, 106 ], [ 4, 398 ], [ 8, 75 ], [ 16, 1 ] ]

##  doc/../gap/blockobj.gd (107-112)
gap> Block( CharacterTable( "A5" ), 2, 1 );
Block( CharacterTable( "A5" ), 2, 1 )
gap> Block( CharacterTable( "A5" ), 2, 3 );
fail

##  doc/../gap/blockobj.gd (147-156)
gap> b:= Block( CharacterTable( "A5" ), 2, 1 );
Block( CharacterTable( "A5" ), 2, 1 )
gap> UnderlyingCharacterTable( b );
CharacterTable( "A5" )
gap> UnderlyingCharacteristic( b );
2
gap> NumberOfBlock( b );
1

##  doc/../gap/blockobj.gd (254-257)
gap> PrincipalBlock( CharacterTable( "A5" ), 2 );
Block( CharacterTable( "A5" ), 2, 1 )

##  doc/../gap/blockobj.gd (181-185)
gap> PBlocks( CharacterTable( "A5" ), 2 );
[ Block( CharacterTable( "A5" ), 2, 1 ), 
  Block( CharacterTable( "A5" ), 2, 2 ) ]

##  doc/../gap/blockobj.gd (287-297)
gap> irr:= Irr( Block( CharacterTable( "A5" ), 2, 1 ) );
[ Character( CharacterTable( "A5" ), [ 1, 1, 1, 1, 1 ] ), 
  Character( CharacterTable( "A5" ),
  [ 3, -1, 0, -E(5)-E(5)^4, -E(5)^2-E(5)^3 ] ), 
  Character( CharacterTable( "A5" ),
  [ 3, -1, 0, -E(5)^2-E(5)^3, -E(5)-E(5)^4 ] ), 
  Character( CharacterTable( "A5" ), [ 5, 1, -1, 0, 0 ] ) ]
gap> irr = Irr( CharacterTable( "A5" ), 2, 1 );
true

##  doc/../gap/blockobj.gd (336-347)
gap> ibr:= IBr( Block( CharacterTable( "A5" ), 2, 1 ) );
[ Character( BrauerTable( "A5", 2 ), [ 1, 1, 1, 1 ] ), 
  Character( BrauerTable( "A5", 2 ),
  [ 2, -1, E(5)+E(5)^4, E(5)^2+E(5)^3 ] ), 
  Character( BrauerTable( "A5", 2 ),
  [ 2, -1, E(5)^2+E(5)^3, E(5)+E(5)^4 ] ) ]
gap> ibr = IBr( CharacterTable( "A5" ) mod 2, 1 );
true
gap> IBr( Block( CharacterTable( "M" ), 2, 1 ) );
fail

##  doc/../gap/blockobj.gd (380-387)
gap> DecompositionMatrix( Block( CharacterTable( "A5" ), 2, 1 ) );
[ [ 1, 0, 0 ], [ 1, 0, 1 ], [ 1, 1, 0 ], [ 1, 1, 1 ] ]
gap> DecompositionMatrix( Block( CharacterTable( "A5" ), 2, 2 ) );
[ [ 1 ] ]
gap> DecompositionMatrix( Block( CharacterTable( "M" ), 2, 1 ) );
fail

##  doc/../gap/blockobj.gd (420-424)
gap> b:= Block( CharacterTable( "M" ), 2, 1 );;
gap> DimensionsOfDecompositionMatrix( b );
[ 183, 55 ]

##  doc/../gap/blockobj.gd (455-458)
gap> List( PBlocks( CharacterTable( "2.A5" ), 3 ), Dimension );
[ 42, 9, 9, 24, 36 ]

##  doc/../gap/blockobj.gd (543-548)
gap> CentralCharacter( CharacterTable( "A5" ), 2, 1 );
[ Z(2)^0, Z(2)^0, 0*Z(2), 0*Z(2), 0*Z(2) ]
gap> CentralCharacter( Block( CharacterTable( "A5" ), 2, 1 ) );
[ Z(2)^0, Z(2)^0, 0*Z(2), 0*Z(2), 0*Z(2) ]

##  doc/../gap/blockobj.gd (592-602)
gap> t:= CharacterTable( "6.A6" );;
gap> List( PBlocks( t, 2 ), ClassPositionsOfKernel );
[ [ 1, 3, 5 ], [ 1, 3, 5 ], [ 1, 3, 5 ], [ 1 ], [ 1 ] ]
gap> List( PBlocks( t, 3 ), ClassPositionsOfKernel );
[ [ 1, 4 ], [ 1, 4 ], [ 1 ] ]
gap> List( PBlocks( t, 5 ), ClassPositionsOfKernel );
[ [ 1, 2, 3, 4, 5, 6 ], [ 1, 2, 3, 4, 5, 6 ], [ 1, 2, 3, 4, 5, 6 ], 
  [ 1, 2, 3, 4, 5, 6 ], [ 1, 3, 5 ], [ 1, 3, 5 ], [ 1, 3, 5 ], 
  [ 1, 4 ], [ 1, 4 ], [ 1, 4 ], [ 1, 4 ], [ 1 ], [ 1 ] ]

##  doc/../gap/blockobj.gd (622-626)
gap> t:= CharacterTable( "6.A6" );;
gap> List( PBlocks( t, 2 ), IsFaithful );
[ false, false, false, true, true ]

##  doc/../gap/blockobj.gd (677-682)
gap> CoefficientsOfOsimaIdempotent( CharacterTable( "A5" ), 2, 1 );
[ 11/15, 0, -1/15, 1/15, 1/15 ]
gap> CoefficientsOfOsimaIdempotent( Block( CharacterTable( "A5" ), 2, 1 ) );
[ 11/15, 0, -1/15, 1/15, 1/15 ]

##  doc/../gap/blockobj.gd (73-84)
gap> tbl:= CharacterTable( "D8" );;
gap> tbl2:= CharacterTable( "A4" );;
gap> IsBlockOfCharacterTable( tbl );
false
gap> IsBlockOfCharacterTable( Block( tbl, 2, 1 ) );
true
gap> Block( tbl, 2, 1 ) = Block( tbl2, 2, 1 );
false
gap> Block( tbl, 2, 1 ) < Block( tbl2, 2, 1 );
true

##  doc/../gap/blocks.gd (125-130)
gap> Defect( Block( CharacterTable( "A5" ), 2, 1 ) );
2
gap> Defect( CharacterTable( "A5" ), 2, 1 );
2

##  doc/../gap/blocks.gd (349-355)
gap> tbl:= CharacterTable( AlternatingGroup( 5 ) );;
gap> DefectGroup( tbl, 2, 1 );
Group([ (2,3)(4,5), (2,4)(3,5) ])
gap> DefectGroup( Block( CharacterTable( "A5" ), 2, 1 ) );
fail

##  doc/../gap/blocks.gd (401-407)
gap> tbl:= CharacterTable( AlternatingGroup( 5 ) );;
gap> NormalizerOfDefectGroup( tbl, 2, 1 );
Group([ (2,3)(4,5), (2,4)(3,5), (3,4,5) ])
gap> NormalizerOfDefectGroup( Block( CharacterTable( "A5" ), 2, 1 ) );
fail

##  doc/../gap/blocks.gd (261-268)
gap> tbl:= CharacterTable( "J2" );;
gap> OrdersClassRepresentatives( tbl );
[ 1, 2, 2, 3, 3, 4, 5, 5, 5, 5, 6, 6, 7, 8, 10, 10, 10, 10, 12, 15, 
  15 ]
gap> ClassPositionsOfDefectGroupOfClass( tbl, 2, 4 );
[ 1, 2, 6 ]

##  doc/../gap/blocks.gd (303-309)
gap> tbl:= CharacterTable( "J2" );;
gap> ClassPositionsOfDefectGroupOfBlock( Block( tbl, 2, 1 ) );
[ 1, 2, 3, 6, 14 ]
gap> ClassPositionsOfDefectGroupOfBlock( tbl, 2, 1 );
[ 1, 2, 3, 6, 14 ]

##  doc/../gap/blocks.gd (433-438)
gap> IsClassWithNormalDefectGroup( CharacterTable( "A5" ), 2, 1 );
false
gap> IsClassWithNormalDefectGroup( CharacterTable( "A5" ), 2, 3 );
true

##  doc/../gap/blocks.gd (467-472)
gap> IsBlockWithNormalDefectGroup( CharacterTable( "A5" ), 2, 1 );
false
gap> IsBlockWithNormalDefectGroup( Block( CharacterTable( "A5" ), 2, 2 ) );
true

##  doc/../gap/blocks.gd (498-503)
gap> IsClassWithCyclicDefectGroup( CharacterTable( "A5" ), 2, 1 );
false
gap> IsClassWithCyclicDefectGroup( CharacterTable( "A5" ), 2, 3 );
true

##  doc/../gap/blocks.gd (532-537)
gap> IsBlockWithCyclicDefectGroup( CharacterTable( "A5" ), 2, 1 );
false
gap> IsBlockWithCyclicDefectGroup( Block( CharacterTable( "A5" ), 2, 2 ) );
true

##  doc/../gap/blocks.gd (665-683)
gap> TestBlockWithAbelianDefectGroup( CharacterTable( "A5" ), 2, 1 );
rec( comment := "defect at most 2", result := true, resultHZC := true 
 )
gap> TestBlockWithAbelianDefectGroup( CharacterTable( "A6" ), 2, 1 );
rec( comment := "not all irreducibles have height zero", 
  result := false, resultHZC := false )
gap> TestBlockWithAbelianDefectGroup( CharacterTable( "J1" ), 2, 1 );
rec( comment := "defect group is an el. ab. 2-group", result := true, 
  resultHZC := true )
gap> TestBlockWithAbelianDefectGroup(
>      CharacterTable( "2.L2(23).2" ), 2, 2 );
rec( comment := "cyclic defect group", result := true, 
  resultHZC := true )
gap> TestBlockWithAbelianDefectGroup(
>      CharacterTable( "U3(11)" ), 2, 2 );
rec( comment := "no criterion yields a decision", result := fail, 
  resultHZC := true )

##  doc/../gap/blocks.gd (693-706)
gap> IsBlockWithAbelianDefectGroup( CharacterTable( "A5" ), 2, 1 );
true
gap> IsBlockWithAbelianDefectGroup( CharacterTable( "A6" ), 2, 1 );
false
gap> IsBlockWithAbelianDefectGroup( CharacterTable( "J1" ), 2, 1 );
true
gap> IsBlockWithAbelianDefectGroup( CharacterTable( "2.L2(23).2" ),
>        2, 2 );
true
gap> IsBlockWithAbelianDefectGroup( CharacterTable( "U3(11)" ),
>        2, 2 );
fail

##  doc/../gap/blocks.gd (170-180)
gap> ClassPositionsOfDefectClasses( CharacterTable( "A5" ), 2, 1 );
[ 1 ]
gap> b:= Block( CharacterTable( "A5" ), 2, 2 );;
gap> ClassPositionsOfDefectClasses( b );
[ 3, 4, 5 ]
gap> b:= Block( CharacterTable( "J4" ), 23, 32 );;
gap> ClassPositionsOfDefectClasses( b );
#I  the Conway polynomial of degree 21 for p = 23 is not known
fail

##  doc/../gap/blocks.gd (221-229)
gap> b:= Block( CharacterTable( "A5" ), 2, 2 );
Block( CharacterTable( "A5" ), 2, 2 )
gap> ClassPositionsOfDefectClassesUpToGaloisConjugacy( b );
[ 3, 4, 5 ]
gap> ClassPositionsOfDefectClassesUpToGaloisConjugacy(
>        CharacterTable( "J4" ), 23, 32 );
[ 2, 3, 5, 6, 7, 14, 15, 16, 19, 20, 34, 57, 58, 59, 60 ]

##  doc/../gap/blocks.gd (775-784)
gap> g:= SmallGroup( 48, 29 );;  # GL(2,3)
gap> syl2:= SylowSubgroup( g, 2 );;
gap> ccl:= ConjugacyClassesSubgroups( syl2 );;
gap> reps:= List( ccl, Representative );;
gap> List( reps, Size );
[ 1, 2, 2, 4, 4, 4, 8, 8, 8, 16 ]
gap> israd:= List( reps, r -> IsRadicalPSubgroup( g, r, 2 ) );
[ false, false, false, false, false, false, true, false, false, true ]

##  doc/../gap/blocks.gd (814-821)
gap> # (continuing the example for IsRadicalPSubgroup)
gap> norm:= List( reps, r -> NormalizerOfRadicalPSubgroup( g, r, 2 ) );
[ fail, fail, fail, fail, fail, fail, Group([ f1, f2, f3, f4, f5 ]), 
  fail, fail, Group([ f1, f3, f4, f5 ]) ]
gap> Positions( israd, false ) = Positions( norm, fail );
true

##  doc/../gap/blocks.gd (909-930)
gap> g:= DihedralGroup( 8 );;
gap> RepresentativesRadicalPSubgroupsAndNormalizers( g, 2 );
[ rec( normalizer := Group([ f1, f2, f3 ]), 
      subgroup := Group([ f1, f2, f3 ]) ) ]
gap> g:= SymmetricGroup( 5 );;
gap> RepresentativesRadicalPSubgroupsAndNormalizers( g, 2 );
[ rec( normalizer := Sym( [ 1 .. 5 ] ), subgroup := Group(()) ), 
  rec( normalizer := Group([ (3,4,5), (3,4), (1,2) ]), 
      subgroup := Group([ (1,2) ]) ), 
  rec( normalizer := Group([ (1,2)(3,4), (1,3)(2,4), (2,4), (2,3) ]), 
      subgroup := Group([ (1,3)(2,4), (1,2)(3,4) ]) ), 
  rec( normalizer := Group([ (1,4)(2,3), (3,4), (1,2) ]), 
      subgroup := Group([ (3,4), (1,2), (1,3)(2,4) ]) ) ]
gap> tom:= TableOfMarks( "A5" );;
gap> RepresentativesRadicalPSubgroupsAndNormalizers( tom, 2 );
[ rec( normalizer := Alt( [ 1 .. 5 ] ), normalizernr := 9, 
      subgroup := Group(()), subgroupnr := 1 ), 
  rec( normalizer := Group([ (2,4)(3,5), (2,3)(4,5), (3,4,5) ]), 
      normalizernr := 8, subgroup := Group([ (2,3)(4,5), (2,4)(3,5) ])
        , subgroupnr := 4 ) ]

##  doc/../gap/blocks.gd (939-947)
gap> g:= AlternatingGroup( 5 );;
gap> r:= rec( Maxes:= [ Stabilizer( g, 5 ) ],
>             CharacterTable:= CharacterTable( "A5" ) );;
gap> RepresentativesRadicalPSubgroupsAndNormalizers( g, 2, r );
[ rec( normalizer := Alt( [ 1 .. 5 ] ), subgroup := Group(()) ), 
  rec( normalizer := Group([ (1,4)(2,3), (1,3)(2,4), (2,3,4) ]), 
      subgroup := Group([ (1,4)(2,3), (1,3)(2,4) ]) ) ]

##  doc/../gap/blocks.gd (1073-1097)
gap> g:= DihedralGroup( 8 );;
gap> RepresentativesChainsOfRadicalPSubgroupsAndNormalizers( g, 2 );
[  ]
gap> g:= SymmetricGroup( 5 );;
gap> RepresentativesChainsOfRadicalPSubgroupsAndNormalizers( g, 2 );
[ [ rec( normalizer := Group([ (3,4,5), (3,4), (1,2) ]), 
          subgroups := [ Group([ (1,2) ]) ] ), 
      rec( normalizer := Group([ (1,2)(3,4), (1,3)(2,4), (2,4), (2,3) 
             ]), subgroups := [ Group([ (1,3)(2,4), (1,2)(3,4) ]) ] ),
      rec( normalizer := Group([ (1,4)(2,3), (3,4), (1,2) ]), 
          subgroups := [ Group([ (3,4), (1,2), (1,3)(2,4) ]) ] ) ], 
  [ 
      rec( normalizer := Group([ (3,4), (1,2) ]), 
          subgroups := 
            [ Group([ (1,2) ]), Group([ (3,4), (1,2), (1,3)(2,4) ]) ] 
         ), 
      rec( normalizer := Group([ (1,4)(2,3), (3,4), (1,2) ]), 
          subgroups := [ Group([ (1,3)(2,4), (1,2)(3,4) ]), 
              Group([ (3,4), (1,2), (1,3)(2,4) ]) ] ) ] ]
gap> tom:= TableOfMarks( "A5" );;
gap> RepresentativesChainsOfRadicalPSubgroupsAndNormalizers( tom, 2 );
[ [ rec( normalizer := Group([ (2,4)(3,5), (2,3)(4,5), (3,4,5) ]), 
          subgroups := [ Group([ (2,3)(4,5), (2,4)(3,5) ]) ] ) ] ]

##  doc/../gap/blocks.gd (1269-1294)
gap> DescriptionOfPWeights( CharacterTable( AlternatingGroup( 5 ) ), 2 );
rec( blocks := [ [ 2 ], [ 1, 1, 1 ] ], 
  characters := 
    [ [ Character( CharacterTable( Alt( [ 1 .. 5 ] ) ),
          [ 4, 0, 1, -1, -1 ] ) ], 
      [ Character( CharacterTable( Alt( [ 1 .. 4 ] ) ),
          [ 1, 1, 1, 1 ] ), 
          Character( CharacterTable( Alt( [ 1 .. 4 ] ) ),
          [ 1, E(3)^2, E(3), 1 ] ), 
          Character( CharacterTable( Alt( [ 1 .. 4 ] ) ),
          [ 1, E(3), E(3)^2, 1 ] ) ] ], 
  normalizers := [ CharacterTable( Alt( [ 1 .. 5 ] ) ), 
      CharacterTable( Alt( [ 1 .. 4 ] ) ) ] )
gap> DescriptionOfPWeights( CharacterTable( AlternatingGroup( 5 ) ), 2, 1 );
rec( 
  characters := 
    [ [  ], [ Character( CharacterTable( Alt( [ 1 .. 4 ] ) ),
          [ 1, 1, 1, 1 ] ), 
          Character( CharacterTable( Alt( [ 1 .. 4 ] ) ),
          [ 1, E(3)^2, E(3), 1 ] ), 
          Character( CharacterTable( Alt( [ 1 .. 4 ] ) ),
          [ 1, E(3), E(3)^2, 1 ] ) ] ], 
  normalizers := [ CharacterTable( Alt( [ 1 .. 5 ] ) ), 
      CharacterTable( Alt( [ 1 .. 4 ] ) ) ] )

##  doc/../gap/blocks.gd (1738-1744)
gap> tbl:= CharacterTable( "M22" );;
gap> List( [ 1 .. NrConjugacyClasses( tbl ) ], 
>          c -> IsRealClass( tbl, c ) );
[ true, true, true, true, true, true, true, false, false, true, 
  false, false ]

##  doc/../gap/blocks.gd (1773-1779)
gap> tbl:= CharacterTable( "M22" );;
gap> List( [ 1 .. NrConjugacyClasses( tbl ) ], 
>          c -> IsStronglyRealClass( tbl, c ) );
[ true, true, true, true, true, true, true, false, false, false, 
  false, false ]

##  doc/../gap/blocks.gd (1809-1814)
gap> IsRealBlock( CharacterTable( "A7" ), 5, 1 );
true
gap> IsRealBlock( Block( CharacterTable( "A7" ), 5, 2 ) );
false

##  doc/../gap/blocks.gd (1846-1852)
gap> tbl:= CharacterTable( "2.A5" );;
gap> IsStronglyRealBlock( Block( tbl, 2, 1 ) );
true
gap> IsStronglyRealBlock( tbl, 2, 2 );
false

##  doc/../gap/blocks.gd (1860-1864)
gap> tbl:= CharacterTable( "A5" );;
gap> IsStronglyRealBlock( tbl, 2, 2 );
true

##  doc/../gap/blocks.gd (1952-1968)
gap> t:= CharacterTable( "A5" );;
gap> AllPBlocks( t );
[ Block( CharacterTable( "A5" ), 2, 1 ), 
  Block( CharacterTable( "A5" ), 2, 2 ), 
  Block( CharacterTable( "A5" ), 3, 1 ), 
  Block( CharacterTable( "A5" ), 3, 2 ), 
  Block( CharacterTable( "A5" ), 3, 3 ), 
  Block( CharacterTable( "A5" ), 5, 1 ), 
  Block( CharacterTable( "A5" ), 5, 2 ) ]
gap> AllPBlocks( t, Defect, 2 );
[ Block( CharacterTable( "A5" ), 2, 1 ) ]
gap> AllPBlocks( t, Defect, IsPosInt );
[ Block( CharacterTable( "A5" ), 2, 1 ), 
  Block( CharacterTable( "A5" ), 3, 1 ), 
  Block( CharacterTable( "A5" ), 5, 1 ) ]

##  doc/../gap/blocks.gd (1991-2001)
gap> t:= CharacterTable( "A5" );;
gap> OnePBlock( t );
Block( CharacterTable( "A5" ), 2, 1 )
gap> OnePBlock( t, UnderlyingCharacteristic, 2 );
Block( CharacterTable( "A5" ), 2, 1 )
gap> OnePBlock( t, Defect, 2 );
Block( CharacterTable( "A5" ), 2, 1 )
gap> OnePBlock( t, Defect, IsPosInt );
Block( CharacterTable( "A5" ), 2, 1 )

##  doc/../gap/blocks.gd (2046-2059)
gap> t:= CharacterTable( "A5" );;
gap> inv:= BlockInvariants( t );;
gap> List( inv.columns, r -> r.label );
[ "p", "b", "d", "k", "l", "c", "a", "n", "f", "r", "sr" ]
gap> Display( inv.list );
[ [ 2, 1, 2, 4, 3, false, true, false, true, true, true ], 
  [ 2, 2, 0, 1, 1, true, true, true, true, true, true ], 
  [ 3, 1, 1, 3, 2, true, true, false, true, true, true ], 
  [ 3, 2, 0, 1, 1, true, true, true, true, true, true ], 
  [ 3, 3, 0, 1, 1, true, true, true, true, true, true ], 
  [ 5, 1, 1, 4, 2, true, true, false, true, true, true ], 
  [ 5, 2, 0, 1, 1, true, true, true, true, true, true ] ]

##  doc/../gap/blocks.gd (2089-2096)
gap> inv:= BlockInvariants( t, UnderlyingCharacteristic, 2 );;
gap> List( inv.columns, r -> r.label );
[ "b", "d", "k", "l", "c", "a", "n", "f", "r", "sr" ]
gap> Display( inv.list );
[ [ 1, 2, 4, 3, false, true, false, true, true, true ], 
  [ 2, 0, 1, 1, true, true, true, true, true, true ] ]

##  doc/../gap/blocks.gd (2130-2151)
gap> origpref:= UserPreference( "AtlasRep", "DisplayFunction" );;
gap> SetUserPreference( "AtlasRep", "DisplayFunction", "Print" );
gap> t:= CharacterTable( "2.A5" );;
gap> DisplayBlockInvariants( t );
Block invariants for 2.A5

----------------------------------------------
| p | b | d | k | l | c | a | n | f | r | sr |
----------------------------------------------
| 2 | 1 | 3 | 7 | 3 | - | - | - | + | + |  + |
|   | 2 | 1 | 2 | 1 | + | + | + | + | + |  - |
| 3 | 1 | 1 | 3 | 2 | + | + | - | - | + |  + |
|   | 2 | 0 | 1 | 1 | + | + | + | - | + |  - |
|   | 3 | 0 | 1 | 1 | + | + | + | - | + |  - |
|   | 4 | 1 | 3 | 2 | + | + | - | + | + |  + |
|   | 5 | 0 | 1 | 1 | + | + | + | + | + |  - |
| 5 | 1 | 1 | 4 | 2 | + | + | - | - | + |  + |
|   | 2 | 0 | 1 | 1 | + | + | + | - | + |  - |
|   | 3 | 1 | 4 | 2 | + | + | - | + | + |  + |
----------------------------------------------

##  doc/../gap/blocks.gd (2161-2172)
gap> DisplayBlockInvariants( t, UnderlyingCharacteristic, 2 );;
Block invariants for 2.A5
p = 2

------------------------------------------
| b | d | k | l | c | a | n | f | r | sr |
------------------------------------------
| 1 | 3 | 7 | 3 | - | - | - | + | + |  + |
| 2 | 1 | 2 | 1 | + | + | + | + | + |  - |
------------------------------------------

##  doc/../gap/blocks.gd (2211-2228)
gap> n:= [ 14, 14, 14, 14, 14, 14 ];;  # ``do nothing''
gap> enter:= [ NCurses.keys.ENTER ];;
gap> BrowseData.SetReplay( Concatenation(
>        "sc",                     # select the 'p' column,
>        "sc",                     # categorize by this column,
>        "X",                      # expand all categories
>        n,                        # wait a little
>        "scrrrrrrr",              # select the 'f' column
>        "f+", enter,              # restrict to the faithful blocks
>        n,                        # wait a little
>        "!",                      # reset the filtering etc.
>        n,                        # wait a little
>        "Q" ) );                  # and quit
gap> t:= CharacterTable( "2.A5" );;
gap> BrowseBlockInvariants( t );
gap> BrowseData.SetReplay( false );

##  doc/../gap/blocks.gi (2117-2120)
gap> CTBlocks.BlockInvariantsColumns[1];
rec( align := "left", fun := function( B ) ... end, label := "G" )

##  doc/../gap/blocks.gi (2131-2153)
gap> cols:= List( [ "c", "a", "n", "f" ],
>                 l -> First( CTBlocks.BlockInvariantsColumns,
>                             r -> r.label = l ) );;
gap> t:= CharacterTable( "2.A5" );; 
gap> DisplayBlockInvariants( t, rec( columns:= cols ) );
Block invariants for 2.A5

-----------------
| c | a | n | f |
-----------------
| - | - | - | + |
| + | + | + | + |
| + | + | - | - |
| + | + | + | - |
| + | + | + | - |
| + | + | - | + |
| + | + | + | + |
| + | + | - | - |
| + | + | + | - |
| + | + | - | + |
-----------------

##  doc/../gap/blocks.gi (2211-2214)
gap> List( CTBlocks.BlockInvariantsColumns, r -> r.label );
[ "G", "p", "b", "d", "k", "l", "c", "a", "n", "f", "r", "sr" ]

##  doc/../gap/blocks.gi (2227-2243)
gap> DisplayBlockInvariants( t, Defect, IsPosInt,
>      rec( columns:= cols,
>           header:= [ "only Boolean invariants" ] ) );
only Boolean invariants

-----------------
| c | a | n | f |
-----------------
| - | - | - | + |
| + | + | + | + |
| + | + | - | - |
| + | + | - | + |
| + | + | - | - |
| + | + | - | + |
-----------------

##  doc/../gap/blocks.gi (2250-2252)
gap> SetUserPreference( "AtlasRep", "DisplayFunction", origpref );

##  doc/../gap/blocks.gd (2291-2302)
gap> tbl:= CharacterTable( "M11" );
CharacterTable( "M11" )
gap> a:= SCAlgebraCentreOfGroupAlgebra( tbl, 3 );
<algebra-with-one of dimension 10 over GF(3)>
gap> a.2 * a.3;
(Z(3))*C2+(Z(3))*C4+C7+C8+(Z(3))*C9+(Z(3))*C10
gap> Dimension( RadicalOfAlgebra( a ) );
8
gap> SCAlgebraCentreOfGroupAlgebra( tbl, GF(9) );
<algebra-with-one of dimension 10 over GF(3^2)>

##  doc/../gap/blocks.gd (2340-2356)
gap> tbl:= CharacterTable( "M11" );
CharacterTable( "M11" )
gap> dec:= BlockDecompositionSCAlgebraCentreOfGroupAlgebra(
>              tbl, 5 );
[ <algebra of dimension 5 over GF(5^2)>, 
  <algebra of dimension 1 over GF(5^2)>, 
  <algebra of dimension 1 over GF(5^2)>, 
  <algebra of dimension 1 over GF(5^2)>, 
  <algebra of dimension 1 over GF(5^2)>, 
  <algebra of dimension 1 over GF(5^2)> ]
gap> List( dec, Dimension );
[ 5, 1, 1, 1, 1, 1 ]
gap> dec:= BlockDecompositionSCAlgebraCentreOfGroupAlgebra(
>              tbl, GF(5) );
fail

##  doc/../gap/blocks.gd (2393-2402)
gap> tbl:= CharacterTable( "M11" );
CharacterTable( "M11" )
gap> SCAlgebraCentreOfBlock( tbl, 5, 1 );
<algebra of dimension 5 over GF(5)>
gap> SCAlgebraCentreOfBlock( tbl, 5, 3 );
<algebra of dimension 1 over GF(5^2)>
gap> SCAlgebraCentreOfBlock( tbl, GF(5), 3 );
fail

##  doc/../gap/gslp.gd (138-150)
gap> gslp:= GeneralizedStraightLineProgram( "union",
>               [ [ [[[1,2]]], 1 ], [ [[[1,3]]], 1 ] ] );
<generalized straight line program>
gap> IsGeneralizedStraightLineProgram( gslp );
true
gap> slp:= StraightLineProgram( [[[1,2]]], 1 );
<straight line program>
gap> IsGeneralizedStraightLineProgram( slp );
true
gap> IsGeneralizedStraightLineProgram( [ slp, slp ] );
false

##  doc/../gap/gslp.gd (295-304)
gap> GeneralizedStraightLineProgram( [[[1,2]]], 1 );
<straight line program>
gap> GeneralizedStraightLineProgram( "union",
> [ [ [[[1,2]]], 1 ], [ [[[1,3]]], 1 ] ] );
<generalized straight line program>
gap> GeneralizedStraightLineProgram( "compose",
> [ [ [[[1,2]]], 1 ], [ [[[1,3]]], 1 ] ] );
<generalized straight line program>

##  doc/../gap/gslp.gd (181-187)
gap> gslp:= GeneralizedStraightLineProgram( "union",
>               [ [ [[[1,2]]], 1 ], [ [[[1,3]]], 1 ] ] );
<generalized straight line program>
gap> DataOfGeneralizedStraightLineProgram( gslp );
[ "union", [ <straight line program>, <straight line program> ] ]

##  doc/../gap/gslp.gd (215-220)
gap> NrInputsOfGeneralizedStraightLineProgram(
>        GeneralizedStraightLineProgram( "union",
>            [ [ [[[1,2]]], 1 ], [ [[[1,3]]], 1 ] ] ) );
1

##  doc/../gap/gslp.gd (247-256)
gap> NrOutputsOfGeneralizedStraightLineProgram(
>        GeneralizedStraightLineProgram( "union",
>            [ [ [[[1,2]]], 1 ], [ [[[1,3]]], 1 ] ] ) );
2
gap> NrOutputsOfGeneralizedStraightLineProgram(
>        GeneralizedStraightLineProgram( "compose",
>            [ [ [[[1,2]]], 1 ], [ [[[1,3]]], 1 ] ] ) );
1

##  doc/../gap/gslp.gd (349-361)
gap> gens:= [ (1,2,3,4,5,6) ];;
gap> gslp:= GeneralizedStraightLineProgram( "union",
>               [ [ [[[1,2]]], 1 ], [ [[[1,3]]], 1 ] ] );
<generalized straight line program>
gap> ResultOfGeneralizedStraightLineProgram( gslp, gens );
[ (1,3,5)(2,4,6), (1,4)(2,5)(3,6) ]
gap> gslp:= GeneralizedStraightLineProgram( "compose",
>               [ [ [[[1,2]]], 1 ], [ [[[1,3]]], 1 ] ] );
<generalized straight line program>
gap> ResultOfGeneralizedStraightLineProgram( gslp, gens );
[ () ]

##  doc/../gap/gslp.gd (393-418)
gap> gslp:= GeneralizedStraightLineProgram( "union",
>               [ [ [[[1,2]]], 1 ], [ [[[1,3]]], 1 ] ] );
<generalized straight line program>
gap> slp:= EquivalentStraightLineProgram( gslp );
<straight line program>
gap> Display( slp );
# input:
r:= [ g1 ];
# program:
# return values:
[ r[1]^2, r[1]^3 ]
gap> gslp:= GeneralizedStraightLineProgram( "compose",
>               [ [ [[[1,2]]], 1 ], [ [[[1,3]]], 1 ] ] );
<generalized straight line program>
gap> slp:= EquivalentStraightLineProgram( gslp );
<straight line program>
gap> Display( slp );
# input:
r:= [ g1 ];
# program:
r[2]:= r[1]^2;
r[1]:= r[2];
# return values:
[ r[1]^3 ]

##  doc/../gap/utils.g (98-108)
gap> PrintOverviewOfDefectOneNormalizers( CharacterTable( "A5" ) );
3: max. subgroup S3
5: max. subgroup D10
gap> PrintOverviewOfDefectOneNormalizers( CharacterTable( "A6" ) );
5: char. table available as D10,
   contained in max. subgroups A5, A6M2
gap> PrintOverviewOfDefectOneNormalizers( CharacterTable( "S10" ) );
7: structure (7x[6]).6,
   contained in max. subgroups S7xS3

##  doc/../gap/blockobj.gd (491-496)
gap> FrobeniusCharacterValue( E(4), 2 );
fail
gap> FrobeniusCharacterValueExt( E(4), 2 );
Z(2)^0

##  doc/utils.xml (79-90)
gap> ReductionToFiniteField( E(5), 2 );
[ x_1^3, 4 ]
gap> ReductionToFiniteField( Sqrt(5), 2 );
[ Z(2)^0, 1 ]
gap> ReductionToFiniteField( E(7), 2 );                               
[ x_1, 3 ]
gap> ReductionToFiniteField( Sqrt(-7), 2 );
[ Z(2)^0, 1 ]
gap> ReductionToFiniteField( Sqrt(7), 2 );  # conductor is 28
fail

##
gap> if IsBound( BrowseData ) then
>      data:= BrowseData.defaults.dynamic.replayDefaults;
>      data.replayInterval:= oldinterval;
>    fi;

##
gap> STOP_TEST( "docxpl.tst" );
gap> SizeScreen( save );;

#############################################################################
##
#E
